#!/bin/bash -x
# vim: set ts=8 shiftwidth=4 softtabstop=4 expandtab smarttab colorcolumn=80:
#
# Copyright (c) 2020 Red Hat, Inc.
# Author: Sergio Correia <scorreia@redhat.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

TEST="${0}"
. tests-common-functions
. clevis-luks-common-functions

function on_exit() {
    [ -d "${TMP}" ] || return 0
    tang_stop "${TMP}"
    rm -rf "${TMP}"
}

trap 'on_exit' EXIT

TMP=$(mktemp -d)

port=$(get_random_port)
tang_run "${TMP}" "${port}" &
tang_wait_until_ready "${port}"

url="http://${TANG_HOST}:${port}"
adv="${TMP}/adv"
tang_get_adv "${port}" "${adv}"

cfg=$(printf '{"url":"%s","adv":"%s"}' "$url" "$adv")

# LUKS1.
DEV="${TMP}/luks1-device"
new_device "luks1" "${DEV}"

if ! clevis luks bind -f -d "${DEV}" tang "${cfg}" <<< "${DEFAULT_PASS}"; then
    error "${TEST}: Bind should have succeeded."
fi

# Now let's remove the initial passphrase.
if ! cryptsetup luksRemoveKey --batch-mode "${DEV}" <<< "${DEFAULT_PASS}"; then
    error "${TEST}: error removing the default password from ${DEV}."
fi

# Making sure we have a single slot enabled.
enabled=$(clevis_luks_used_slots "${DEV}" | wc -l)
if [ "${enabled}" -ne 1 ]; then
    error "${TEST}: we should have only one slot enabled (${enabled})."
fi

old_key=$(clevis_luks_unlock_device_by_slot "${DEV}" "${SLT}")

# Now let's try regen.
SLT=1
if ! clevis luks regen -q -d "${DEV}" -s "${SLT}"; then
    error "${TEST}: clevis luks regen failed"
fi

new_key=$(clevis_luks_unlock_device_by_slot "${DEV}" "${SLT}")

if [ "${old_key}" = "${new_key}" ]; then
    error "${TEST}: the passphrases should be different"
fi
